


#define WDM_NONE_ISLAND		"open_sea"
float	WDM_MAP_TO_SEA_SCALE;					// Set in function InitOpenSeaMod() in PROGRAM\NK.c
float	WDM_MAP_TO_SEA_ENCOUNTERS_SCALE;		// Set in function InitOpenSeaMod() in PROGRAM\NK.c

#define	AMOUNT_TOWNS  		3	//Amount of towns taken into account with the encounters

#define WDM_ETYPE_MERCHANT	0
#define WDM_ETYPE_FOLLOW	1
#define WDM_ETYPE_WARRING	2
#define WDM_ETYPE_PIRATE	3


object worldMap;

string wdmCurrentIsland = WDM_NONE_ISLAND;


//=========================================================================================
//Util functions
//=========================================================================================

//Storm functions

int wdmGetNumberStorms()
{
	return MakeInt(worldMap.storm.num);
}

void wdmCreateStorm()
{
	SendMessage(&worldMap, "l", MSG_WORLDMAP_CREATESTORM);
}

//Ship encounter functions

int wdmGetNumberShipEncounters()
{
	return MakeInt(worldMap.encounter.num);
}

bool wdmSetCurrentShipData(int shipIndex)
{
	worldMap.encounter.cur = shipIndex;
	int i = MakeInt(worldMap.encounter.cur);
	if(i < 0 || i != shipIndex) return 0;
	return 1;
}

bool wdmCreateMerchantShip(int type, string islandName, float dltSpeedInPMPercents)
{
	float kSpeed = dltSpeedInPMPercents/100.0;
	if(kSpeed >= 0.0)
	{
		kSpeed = kSpeed + 1.0;
	}else{
		kSpeed = 1.0/(1.0 - kSpeed);
	}
	string nationShipName = wdmEncounterModelName(type);
	return SendMessage(&worldMap, "llssf", MSG_WORLDMAP_CREATEENC_MER, type, nationShipName, islandName, kSpeed);
}

//if islandName == "" then island finding automatically
bool wdmCreateMerchantShipTime(int type, string islandName, float dltSpeedInPMPercents, float liveTime)
{
	float kSpeed = dltSpeedInPMPercents/100.0;
	if(kSpeed >= 0.0)
	{
		kSpeed = kSpeed + 1.0;
	}else{
		kSpeed = 1.0/(1.0 - kSpeed);
	}
	if(liveTime < 1.0) liveTime = 1.0;
	string nationShipName = wdmEncounterModelName(type);
	return SendMessage(&worldMap, "llssff", MSG_WORLDMAP_CREATEENC_MER_TIME, type, nationShipName, islandName, kSpeed, liveTime);
}

bool wdmCreateFollowShip(int type, float dltSpeedInPMPercents)
{
	float kSpeed = dltSpeedInPMPercents/100.0;
	if(kSpeed >= 0.0)
	{
		kSpeed = kSpeed + 1.0;
	}else{
		kSpeed = 1.0/(1.0 - kSpeed);
	}
	string nationShipName = wdmEncounterModelName(type);
	return SendMessage(&worldMap, "llsf", MSG_WORLDMAP_CREATEENC_FLW, type, nationShipName, kSpeed);
}

bool wdmCreateFollowShipTime(int type, float dltSpeedInPMPercents, float liveTime)
{
	float kSpeed = dltSpeedInPMPercents/100.0;
	if(kSpeed >= 0.0)
	{
		kSpeed = kSpeed + 1.0;
	}else{
		kSpeed = 1.0/(1.0 - kSpeed);
	}
	if(liveTime < 1.0) liveTime = 1.0;
	string nationShipName = wdmEncounterModelName(type);
	return SendMessage(&worldMap, "llsff", MSG_WORLDMAP_CREATEENC_FLW_TIME, type, nationShipName, kSpeed, liveTime);
}

bool wdmCreateWarringShips(int type1, int type2)
{
	string nationShipName1 = wdmEncounterModelName(type1);
	string nationShipName2 = wdmEncounterModelName(type2);
	return SendMessage(&worldMap, "llsls", MSG_WORLDMAP_CREATEENC_WAR, type1, nationShipName1, type2, nationShipName2);
}

bool wdmCreateWarringShipsTime(int type1, int type2, float liveTime)
{
	if(liveTime < 1.0) liveTime = 1.0;
	string nationShipName1 = wdmEncounterModelName(type1);
	string nationShipName2 = wdmEncounterModelName(type2);
	return SendMessage(&worldMap, "llslsf", MSG_WORLDMAP_CREATEENC_WAR_TIME, type1, nationShipName1, type2, nationShipName2, liveTime);
}


void wdmReleaseEncounters()
{
	SendMessage(&worldMap, "l", MSG_WORLDMAP_CREATEENC_RELEASE);
}

//Interface

void wdmMessage(string text, string yes, string no)
{
	worldMap.eventWindow.text = text;
	worldMap.eventWindow.yes = yes;
	worldMap.eventWindow.no = no;
	worldMap.eventWindow.update = "";
}

void wdmWaitMenu()
{
	worldMap.waitMenu.update = "";
}

string wdmEncounterModelName(int encIndex)
{
	ref n = GetMapEncounterNationRef(encIndex);
	if(CheckAttribute(n, "worldMapShip") != 0)
	{
		string shipname = n.worldMapShip;
		// NK 05-03-23 add wdm ship model setting -->
		switch(WDMAP_SHIP_SHOW_MODE)
		{
			case 1: if(sti(n.index) != PIRATE) shipname = "ship"; break;
			case 2: shipname = "ship"; break;
			case 3: shipname = "nomodel"; break;
		}
		return shipname;
		// NK <--
	}
	return "ship";	
}

//Levis Better encounter functions

float getEncounterChance(float timeinterval)
{
	// Create a array for the closest towns
	int Towns[AMOUNT_TOWNS], Distance[AMOUNT_TOWNS];
	float Traderships = 0.0;
	float Militiaships = 0.0;
	float Warringships = 0.0;
	float Pirateships = 0.0;
	//Loop trough all towns
	for(int i = 0; i < TOWNS_QUANTITY; i++)
	{
		float dis = getDistanceToTown(i);
		// Check if its one of the closest towns
		for(int j = 0; j < AMOUNT_TOWNS; j++)
		{
			if(dis < Distance[j] || Distance[j]==0)
			{
				for(int k = j; k < AMOUNT_TOWNS; k++)
				{
					if(k<(AMOUNT_TOWNS-1))
					{
						Towns[(k+1)] = Towns[k];
						Distance[(k+1)] = Distance[k];
					}
				}
				Towns[j] = i;
				Distance[j] = dis;
				break;
			}
		}
	}
	// Set the closest island
	ref Town = GetTownByIndex(Towns[0]);
	string islandID = Town.island;
	worldMap.cIsland = islandID;
	// Check the chances for the 3 closest towns and add them together.
	for(j = 0; j < AMOUNT_TOWNS; j++)
	{
		Traderships += calcShips(Towns[j],Distance[j], "trader");
		Militiaships += calcShips(Towns[j],Distance[j], "militia");
	}
	// Check if there could be any battle
	if((Militiaships+Traderships)>2)
	{
		//There need to be at least 2 fleets in the vicinity
		//The more ships there are in the area the larger the chance of a battle.
		Warringships = getWarringFleet( (Militiaships+Traderships) , Distance[0], Distance[1]);
		if(Warringships>(Militiaships+Traderships))
		{
			//Hope this never happens but just to be sure
			Warringships = (Militiaships+Traderships);
		}
		//See how much we need to substract from trader and militia
		float part_trader = Traderships / (Militiaships+Traderships);
		Traderships -= Warringships*part_trader;
		Militiaships -= Warringships*(1.0-part_trader);
	}
	// Check how many pirate ships there will be
	Pirateships = getPirateFleet(Traderships, Militiaships);
	// During full moon we have more pirates but only during the night
	if(!IsDay())
	{
		if(IsFullMoon(0))
		{
			Pirateships = Pirateships*2.5;
		}
	}
	//Set the worldmap variables
	worldMap.warring_chance_trader = part_trader;
	worldMap.warring_chance = Warringships * getTimeCorrector() * (timeinterval/24.0) * 100.0;
	worldMap.merchant_chance = Traderships * getTimeCorrector() * (timeinterval/24.0) * 100.0;
	worldMap.follow_chance = Militiaships * getTimeCorrector() * (timeinterval/24.0) * 100.0;
	worldMap.pirate_chance = Pirateships * (2.0-getTimeCorrector()) * (timeinterval/24.0) * 100.0;
	//Return the total amount of ships per day which can be seen
	return ((Warringships/2.0)+Traderships+Militiaships)
}

float calcShips(int idx, int dis, string type)
{
	// Get the island
	ref Town = GetTownByIndex(idx);
	string islandName = Town.island;
	aref island;
	makearef(island, worldMap.islands.(islandName));
	float radius = island.radius;
	//This function calculates how many ships you should see sail by on a day on your current location.
	int fleetsize, enc_const;
	switch(type)
	{
		case "trader":
			fleetsize = getTownTraderFleet(idx);
			enc_const = 60;
		break;
		
		case "militia":
			fleetsize = getTownMilitiaFleet(idx);
			enc_const = 55;
		break;
	}
	float ships_per_day = (fleetsize*2.0*enc_const*pow(radius,0.3)*pow(dis,0.55))/(sqr(dis));
	if (ships_per_day > fleetsize)
	{
		ships_per_day = fleetsize;
	}
	return ships_per_day
}

float getWarringFleet(int totalships, float d1, float d2)
{
	// This function determines the amount of battling fleets
	// Good luck figuring out the math
	float disper = 1.0 - (sqrt(sqr(d1-d2)) / 400.0);
	float ships = (pow((totalships+2.0),(1.0+pow((totalships+2.0),0.1)))*disper)/100.0;
	return ships
}

float getPirateFleet(float tships, float mships)
{
	//This function determines how many pirate ships there are
	float pships = (tships+1.0)*1.4-pow((1.5),(mships+(tships/4.0)))-mships;
	if(pships < 0.0)
	{
		return 0.0
	}
	return pships
}

int getTownTraderFleet(int idx)
{
	// Get the island
	ref Town = GetTownByIndex(idx);
	string islandName = Town.island;
	aref island;
	makearef(island, worldMap.islands.(islandName));
	// Calculate how many traders the town has
	return 4
}

int getTownMilitiaFleet(int idx)
{
	// Get the island
	ref Town = GetTownByIndex(idx);
	string islandName = Town.island;
	aref island;
	makearef(island, worldMap.islands.(islandName));
	// Calculate how many traders the town has
	return 3
}

float getDistanceToTown(int idx)
{
	// Get player location
	float pX = MakeFloat(worldMap.playerShipX);
	float pZ = MakeFloat(worldMap.playerShipZ);
	// Get the island
	ref Town = GetTownByIndex(idx);
	string islandName = Town.island;
	aref locations;
	makearef(locations, worldMap.islands.(islandName).locations);
	// Check which location on the island we need to have
	int num = GetAttributesNum(locations);
	for(int i = 0; i < num; i++)
	{
		aref loc = GetAttributeN(locations, i);
		if(!CheckAttribute(loc, "name")) continue;
		if(loc.name == Town.id)
		{
			return GetDistance2D(pX, pZ, MakeFloat(loc.position.x), MakeFloat(loc.position.z));
		}
	}
	// If we can't find the town return the coords of the island as backup
	return GetDistance2D(pX, MakeFloat(worldMap.islands.(islandName).position.x), pZ, MakeFloat(worldMap.islands.(islandName).position.z));
}

float timeSinceLastUpdate(float hours, float minutes)
{
	float interval;
	//This function returns the amount of hours since the last update
	float time = hours + (minutes/60.0);
	if(CheckAttribute(worldmap,"lastupdate"))
	{
		float last = MakeFloat(worldmap.lastupdate);
		int add = 0;
		if(last>time)
		{
			add = 24.0;
		}
		interval = (time + add) - last;
	}
	else
	{
		interval = MakeFloat(worldMap.date.hourPerSec);
	}
	worldmap.lastupdate = time;
	return interval;	
}

float getTimeCorrector()
{
	//This function is a sinus function over a whole day
	float timec = (sin((GetHour()-8.0)/12.0*PI)+1.5)/2.0;
	return timec
}

float chanceShipFromIsland()
{
	//Has to be made variable at some point.
	return 50.0;
}